static char rcsid[] = "@(#)$Id: mkhdrs.c,v 1.25.8.3 2007/04/05 19:44:50 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.25.8.3 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *                       (was hurtta+elm@ozone.FMI.FI)
 *           or  Kari Hurtta <elm@elmme-mailer.org>
 ******************************************************************************
 *  Based on Elm 2.4 src/mkhdrs.c. That code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/** This contains the header generating routines for the ELM
    program.
**/

#include "def_elm.h"
#include "s_elm.h"

#include <errno.h>
#ifndef ANSI_C
extern int errno;
#endif       

#if 0
DEBUG_VAR(Debug,__FILE__,"header");
#endif


static unsigned char *s2us P_((char *str));
static unsigned char *s2us(str) 
     char *str;
{
    return (unsigned char *)str;
}

static const unsigned char *cs2us P_((const char *str));
static const unsigned char *cs2us(str) 
     const char *str;
{
    return (const unsigned char *)str;
}


void generate_reply_to(current_header,headers)
     struct header_rec * current_header;
     struct mailing_headers *headers;
{
    /** Generate an 'in-reply-to' message... **/
    char date_buf[SLEN];
    int found = 0;

    free_id_phrase(&(headers->in_reply_to));

    if (add_irt_phrase) {
	headers->in_reply_to.text = new_string(display_charset);
    
	if (current_header->messageid) {
	    headers->in_reply_to.id = safe_strdup(current_header->messageid);
	    add_ascii_to_string(headers->in_reply_to.text,s2us(" from "));
	} else
	    add_ascii_to_string(headers->in_reply_to.text,s2us("From "));
	
	if (current_header) {	

	    if (current_header->from) {
		int idx;
		int len   = addr_list_item_count(current_header->from);
		
		for (idx = 0; idx < 0; idx++) {
		    int group = -1;
		    const struct address * address = 
			addr_list_get_item(current_header->from,idx,&group);
	
		    const char          * addr        = address_get_ascii_addr(address);
		    const struct string * fullname    = address_get_phrase(address);
		
		    if (found)
			add_ascii_to_string(headers->in_reply_to.text,s2us(", "));
		
		    if (fullname && string_len(fullname)) {

			append_string(& headers->in_reply_to.text,
				      fullname);

			found++;
		

		    } else if (addr) {
			add_ascii_to_string(headers->in_reply_to.text,
					    cs2us(addr));	    
			found++;
		    }
		}
	    }
	    
	    if (!found && current_header->env_from[0]) {
		add_ascii_to_string(headers->in_reply_to.text,s2us("(env: "));
		add_ascii_to_string(headers->in_reply_to.text,
				    s2us(current_header->env_from));
		add_ascii_to_string(headers->in_reply_to.text,s2us(")"));
	    } else if (!found)
		add_ascii_to_string(headers->in_reply_to.text,s2us("someone"));


	    add_ascii_to_string(headers->in_reply_to.text,s2us(" at "));
	    add_ascii_to_string(headers->in_reply_to.text,
				s2us(elm_date_str(date_buf,
						  current_header->time_sent +
						  current_header->tz_offset,
						  sizeof date_buf)));
	}


    } else if (current_header->messageid) {
	/* RFC 2822 (obsoletes RFC 822) says that in-reply-to
	   header should only include message-id
	*/
	headers->in_reply_to.id = safe_strdup(current_header->messageid);
    }
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
